// Converts a boolean to Yes or No.
Handlebars.registerHelper('YesNo', function(val)
{
  if(val)
  {
  	return "Yes";
  }else{
  	return "No";
  }
});

// Converts a boolean to a checked attribute for checkboxes
Handlebars.registerHelper('Checked', function(val)
{
  if(val)
  {
  	return "checked=checked";
  }else{
  	return "";
  }
});

// Used in the ViewAllEntries view to get month title e.g. January 2012
Handlebars.registerHelper('MonthTitle', function(strDate)
{
	return new Date(strDate).toString("MMMM yyyy");
});

Handlebars.registerHelper('ShortDate', function(dateStr)
{
	return new Date(dateStr).toString("dd MMM yyyy");
});

Handlebars.registerHelper('ShortTime', function(dateStr)
{
	return new Date(dateStr).toString("HH:mm");
});


Handlebars.registerHelper('LongDate', function(dateStr)
{
	return new Date(dateStr).toString("dd MMM yyyy HH:mm");
});

// Used in the ViewAllEntries view to show the month breakdown.
Handlebars.registerHelper('MonthEntries', function(entries, month, fn)
{
	var buffer = [];
	var len = entries[month].length;
	
	for(var i = 0; i < len; i++)
	{
		buffer[buffer.length] = fn({ id : entries[month][i].id, date : new Date(entries[month][i].dateAdded).toString("dd MMM yyyy HH:mm") });
	}
	return buffer.join("");
});
