var database = { 
        
        // delete all the data
        nukeData : function(callback) {
                console.log("Nuking all data...");
                var databaseNames = [ 'diary' ];
                for (var i = 0; i < databaseNames.length; i++) {
                        var x = Lawnchair({name:databaseNames[i]},function(){
                                          this.nuke();
                                          });
                }
                if(callback != undefined)
                {
                	callback();
                }
        },
        
        // Get the entry by id
        getEntry : function(id, callback)
        {
        	var db = Lawnchair({name:'diary'}, function()
        	{
        		this.get(id, callback);
        	});
        },
        
        // Save currentEntry to the database                                              
        saveEntry : function(entry, callback) {   
                var db = Lawnchair({name:'diary'},
                	function(){
                       	if(!entry.dateAdded)
                       	{
                       		entry.dateAdded = new Date().toString(dateTimeFormat);
                       	}else{
                       		var da = new Date(entry.dateAdded);
                       		entry.dateAdded = da.toString(dateTimeFormat);
                       		//entry.dateAdded = entry.dateAdded.toString(dateTimeFormat);
                       	}
                       	if(!entry.id)
                       	{
                       		entry.id = new Date().getTime().toString();
                       	}
                       	this.save({key:entry.id,value:jQuery.extend(true, {}, entry)}, function() {
                                             	if(callback)
								                {
								                	console.log("Data saved to diary with id " + entry.id.toString() + " " + entry.dateAdded);
								                	callback();
								                }
                                             });
                    });
        },
        
        // get all entries
        getAllEntries : function(callback){
        	var db = Lawnchair({name:'diary'}, function(){
        		this.all(function(data)
        		{
        			data.sort(SortEntriesByDateAdded);
        			callback(data);
        		});
        	});
        },
        
        // get todays entry. If none return a copy of defaults
        getAllForDay : function(day, callback)
        {

        	var todayMatch = day.toDateString();

        	
        	var cb = callback;
        	var db = Lawnchair({name:'diary'}, function()
        	{
        		this.all(function(data)
        		{
        			var result = [];
        			/*console.log( JSON.stringify(data[1].value));
        			var tesst = data[0].value.dateAdded;
        			console.log(tesst);
        			tesst = Date.parseExact(tesst, "MMM dd, yyy HH:mm:ss tt");
        			console.log(tesst);
        			tesst = tesst.toDateString();
        			console.log(tesst);*/
        			//console.log(JSON.stringify(data[0].value));
        			for (var i = 0; i < data.length; i++) {
        				//if(todayMatch === Date.parseExact(data[i].value.dateAdded, "MMM dd, yyy HH:mm:ss tt"))
        				//console.log("today" + todayMatch + " other " data[i].value.dateAdded.toString("ddd MMM d yyyy"));
        				var ddd = new Date(data[i].value.dateAdded);
        				if(todayMatch === ddd.toDateString())
	        			{
	        				result.push(data[i].value);
	        			}
	        		}
	        		
	        		result.sort(SortEntriesByDateAdded);
	        		callback(result);
        		});
        	});
        },
        
        // Get the latest entry for today
        getLatestForToday : function(callback)
        {
        	this.getAllForDay(new Date(), function(data)
        	{
        		if(data.length == 0)
        		{
        			callback(null);
        		}else{
        			data.sort(SortEntriesByDateAdded);
        			callback(data[0]);
        		}

        	});
        },
        
        getLast24Hours : function(callback)
        {
        	
        	this.getAllEntries(function(data)
        	{
        		var result = [];
        		var nowTime = new Date().getTime();
        		$(data).each(function(idx, entry)
        		{
        			//if((Date.parse(entry.value.dateAdded).getTime()-nowTime)/one_day > -1)
        			var dateAdded = new Date(entry.value.dateAdded);
        			try{
    					dateAdded = dateAdded.getTime();
    					//console.log((dateAdded - nowTime) + " " + entry.value.dateAdded + " " + one_day);
        			}catch (e){
        				console.log(e);
        			}
        			
        			//if(((dateAdded.getTime()-nowTime)/one_day) > -1)
        			
        			if(((dateAdded-nowTime)/one_day) > -1)
        			{
        				result.push(entry.value);
        			}else{
        				return false;
        			}
        		});
        		callback(result);
        	});
        },
        
        getWithinDates : function(startDate, endDate, callback)
        {
        	var startTime = startDate.clone().clearTime();
        	var endTime = endDate.clone().addDays(1).clearTime().addMinutes(-1);
        	this.getAllEntries(function(data)
        	{
        		var result = [];
        		$(data).each(function(idx, entry)
        		{
        			//if(Date.parseExact(entry.value.dateAdded, "MMM dd, yyy HH:mm:ss tt").between(startTime, endTime))
        			//console.log(entry.value.dateAdded);
    				if(Date.parse(entry.value.dateAdded).between(startTime, endTime))
        			{
        				result.push(entry.value);
        			}
        		});
        		callback(result);
        	});
        },
                
	// Load in test data from .json file
        loadTestData : function(amount)
        {
        	$.getJSON('testData/testData.json', function(data)
        	{
        		var one_hour = 1000*60*60;
        		var today = new Date();
        		// 3 stools a day
        		var h = 0.1
        		var l = data.length;
        		var toSave = []
        		for(h; h < amount; h++)
    			{
					var item = jQuery.extend(true, {}, data[Math.floor(Math.random() * l)]);
					var dateAdded = new Date(today - (one_hour * h * 11));
					item.dateAdded = dateAdded.toString(dateTimeFormat);
					item.id = dateAdded.getTime().toString();
					toSave.push({key:item.id,value:item});
    			}
        		
        		var db = Lawnchair({name:'diary'}, function(){
					this.batch(toSave, function(){DoneLoading();});
        		});
        	});
        },
        
        // Loads backup text file
        loadBackup : function(backup)
        {
        	var arr = [],
        		bm = 0,
        		backedup = JSON.parse(backup);
        	
        	for (bm; bm < backedup.length; bm++) {
        		arr.push(backedup[bm]);
        	}
        	
        	var db = Lawnchair({name:'diary'}, function(){
				this.batch(arr, function(){
					DoneLoading();
				});
    		});
        }
}