views.foodDiaries24 = function()
{
	var loadEntries = function()
	{
		database.getLast24Hours(function(data)
		{
			var tpl = Handlebars.compile(TemplateLoader.templates['foodDiaries']);
			var entries = [];
			$(data).each(function(idx, item)
			{
				if(item.foodDiary.length > 0)
				{
					entries.push(item);
				}
			});
			$('#content').html(tpl({entries : entries}));
			$('.back').attr('href', '#graphs24');
			SetupScroller();
			DoneLoading();
		});
	}
	ShowLoading();
	window.setTimeout(function() {
		loadEntries();
	}, 0);

}

views.foodDiariesWeek = function()
{
	var loadEntries = function()
	{
		var dateFrom = Date.parse(getParameterByName("from"));
		var dateTo = Date.parse(getParameterByName("to")).addDays(1).clearTime().addMinutes(-1);
		
		database.getWithinDates(dateFrom, dateTo, function(data)
		{
			var tpl = Handlebars.compile(TemplateLoader.templates['foodDiaries']);
			var entries = [];
			$(data).each(function(idx, item)
			{
				if(item.foodDiary.length > 0)
				{
					entries.push(item);
				}
			});
			$('#content').html(tpl({entries : entries}));
			var url = "#graphsWeek?from=" + dateFrom.toString("dd-MMM-yyyy") + "&to=" + dateTo.toString("dd-MMM-yyyy");
			$(".back").attr("href", url);
			SetupScroller();
			DoneLoading();
		});
	}
	
	ShowLoading();
	window.setTimeout(function() {
		loadEntries();
	}, 0);
}

views.foodDiariesMonth = function()
{
	var loadEntries = function()
	{
		var dateFrom = Date.parse(getParameterByName("from"));
		var dateTo = Date.parse(getParameterByName("to")).addDays(1).clearTime().addMinutes(-1);
		
		database.getWithinDates(dateFrom, dateTo, function(data)
		{
			var tpl = Handlebars.compile(TemplateLoader.templates['foodDiaries']);
			
			var entries = [];
			$(data).each(function(idx, item)
			{
				if(item.foodDiary.length > 0)
				{
					entries.push(item);
				}
			});
			$('#content').html(tpl({entries : entries}));
			var url = "#graphsMonth?from=" + dateFrom.toString("dd-MMM-yyyy") + "&to=" + dateTo.toString("dd-MMM-yyyy");
			$(".back").attr("href", url);
			SetupScroller();
			DoneLoading();
		});
	}
	
	ShowLoading();
	window.setTimeout(function() {
		loadEntries();
	}, 0);
}
