views.graphs24 = function()
{
	var render = function()
	{
		database.getLast24Hours(function(data)
		{
			var nowTime = new Date().getTime();
			
			var LoadStoolGraph = function()
			{
				var options = { grid: { clickable: false } };
			   	options.yaxis = { ticks: [1, 2, 3, 4, 5, 6, 7], tickDecimals : 0, min : 0, max : 8, axisLabel: 'Stool type' };
			   	options.xaxis = { ticks : [-24, -20, -16, -12, -8, -4, [0, "Now"]], tickDecimals : 0, max : 1, min : -25, axisLabel: 'Time' };
			   	options.lines = { show : true, fill : true, fillColor : "rgba(216, 58, 47, 0.3)" };
			   	options.points = { show : true };
				var points = { color : "rgb(216, 58, 47)", data : [] };
				
				$(data).each(function(idx, item)
				{
					if(item.bowelMovement)
					{
						//var dateAdded = Date.parse(item.dateAdded);
						var dateAdded = new Date(item.dateAdded);
						var diff = GetHoursSince(dateAdded, nowTime);
						points.data.push([diff, parseInt(item.bowelMovement.type)]);
					}
				});
				
			    $.plot($("#stoolGraph"), [points], options);
			}
			
			var LoadSymptomsGraph = function()
			{
				var options = { grid: { clickable: false } };
			   	options.yaxis = { ticks: [1, 2, 3, 4, 5], tickDecimals : 0, min : 0, max : 6, axisLabel: 'Level' };
			   	options.xaxis = { ticks : [-24, -20, -16, -12, -8, -4, [0, "Now"]], tickDecimals : 0, max : 1, min : -25, axisLabel: 'Time' };
			   	options.lines = { show : true };
			   	options.points = { show : true };
			   	
			   	var points = {};
			   	
				points.feeling = {color : "rgb(73, 118, 51)", data : []};
				points.painLevel = {color : "#d5571d", data : []};
				points.stressLevel = {color : "rgb(75, 120, 196)", data : []};
				points.bloatingLevel = {color : "rgb(155, 0, 13)", data : []};
				points.nauseaLevel = {color : "#a08cb8", data : []};
				points.anxietyLevel = {color : "rgb(190, 108, 26)", data : []};
				points.lethargyLevel = {color : "rgb(121, 118, 124)", data : []};
				
				$(data).each(function(idx, item)
				{
					//var dateAdded = Date.parse(item.dateAdded);
					var dateAdded = new Date(item.dateAdded);
					var diff = GetHoursSince(dateAdded, nowTime);
					
					points.feeling.data.push([diff, parseInt(item.feeling)]);
					points.painLevel.data.push([diff, parseInt(item.painLevel)]);
					points.stressLevel.data.push([diff, parseInt(item.stressLevel)]);
					points.bloatingLevel.data.push([diff, parseInt(item.bloatingLevel)]);
					points.nauseaLevel.data.push([diff, parseInt(item.nauseaLevel)]);
					points.anxietyLevel.data.push([diff, parseInt(item.anxietyLevel)]);
					points.lethargyLevel.data.push([diff, parseInt(item.lethargyLevel)]);
					
				});
				
				var showAll = [ points.feeling, points.painLevel, points.stressLevel, points.bloatingLevel, points.nauseaLevel, points.anxietyLevel, points.lethargyLevel ];
				
			    var graph = $.plot($("#symptomsGraph"), showAll, options);
				
								
			    $('.symptomsFilters span').tap(function()
			    {
					// [DC] Prevent double-taps after recording a BM
					if (readyFlag == true) {
						readyFlag = false;
						setTimeout(function() { readyFlag = true; }, 50);
					}
					else {
						//console.log("denied!");
						return;
					}
					//console.log("Tap!");
											   
			    	$(this).toggleClass('selected');
			    	
			    	if(this.id == "showAll" || $('.symptomsFilters span.selected').length == 0)
			    	{
			    		$('.symptomsFilters span').removeClass('selected');
			    		$('.symptomsFilters #showAll').addClass('selected');
			    		graph.setData(showAll);
			    	}else{
			    		$(".symptomsFilters #showAll").removeClass('selected');
			    		var selected = [];
			    		$('.symptomsFilters span.selected').each(function(idx, item)
			    		{
			    			selected.push(points[$(item).attr('id')]);
			    		});
			    		graph.setData(selected);
			    	}
			    	
		    		graph.setupGrid(); //only necessary if your new data will change the axes or grid
					graph.draw();
			    	
			    });
			}
			
			var LoadActivitiesGraph = function()
			{
				var options = { grid: { clickable: false } };
			   	options.xaxes = [ { ticks : [-24, -20, -16, -12, -8, -4, [0, "Now"]], tickDecimals : 0, max : 1, min : -25, axisLabel: 'Time' } ];
	    		options.yaxes = [ 
	    			{ ticks: [1, 2, 3, 4, 5], tickDecimals : 0, min : 0, max : 6, axisLabel: 'Amount of exercise' },
	    			{ ticks: [0, 5, 10, 15, 20], tickDecimals : 0, min : -1, max : 21, position: "right", axisLabel: 'Cups of fluid' }
	    		];
			   	
			   	options.lines = { show : true };
			   	options.points = { show : true };
			   	var points = {};
				points.activityLevel = { color : "rgb(207, 0, 74)", data : [], yaxis : 1 };
				points.fluidCups = { color : "rgb(30, 98, 170)", data : [], yaxis : 2 };
				$(data).each(function(idx, item)
				{
					//var dateAdded = Date.parse(item.dateAdded);
					var dateAdded = new Date(item.dateAdded);
					var diff = GetHoursSince(dateAdded, nowTime);
					points.activityLevel.data.push([diff, parseInt(item.activityLevel)]);
					points.fluidCups.data.push([diff, parseInt(item.fluidCups)]);
				});
				var showAll = [ points.activityLevel, points.fluidCups ];
				
			    var graph = $.plot($("#activitiesGraph"), showAll, options);
			    
			    $('.activitiesFilters span').tap(function()
			    {
												 // [DC] Prevent double-taps after recording a BM
												 if (readyFlag == true) {
												 readyFlag = false;
												 setTimeout(function() { readyFlag = true; }, 50);
												 }
												 else {
												 //console.log("denied!");
												 return;
												 }
												 //console.log("Tap!");
			    	$(this).toggleClass('selected');
	
			    	if(this.id == "showAll" || $('.activitiesFilters span.selected').length == 0)
			    	{
			    		$('.activitiesFilters span').removeClass('selected');
			    		$('.activitiesFilters #showAll').addClass('selected');
			    		graph.setData(showAll);
			    	}else{
			    		$('.activitiesFilters #showAll').removeClass('selected');
			    		var selected = [];
			    		$('.activitiesFilters span.selected').each(function(idx, item)
			    		{
			    			selected.push(points[$(item).attr('id')]);
			    		});
			    		graph.setData(selected);
			    	}
			    	
		    		graph.setupGrid(); //only necessary if your new data will change the axes or grid
					graph.draw();
					
					//Now sort out the y labels.
					$('#activitiesGraph .yaxisLabel, #activitiesGraph .y2axisLabel').hide();
					if($('.activitiesFilters #showAll.selected').length > 0)
					{
						$('#activitiesGraph .axisLabels').show();
					}
	    			if($('.activitiesFilters #fluidCups.selected').length > 0)
		    		{
		    			$('#activitiesGraph .y2axisLabel').show();
		    		}
		    		if($('.activitiesFilters #activityLevel.selected').length > 0)
		    		{
		    			$('#activitiesGraph .yaxisLabel').show();
		    		}
			    });
			}
			
			LoadStoolGraph();
			LoadSymptomsGraph();
			LoadActivitiesGraph();
			DoneLoading();
		});
	};
	
	var html = TemplateLoader.templates['graphs24'];
	$('#content').html(html);
	SetupScroller();
	ShowLoading();
	
	window.setTimeout(function() {
		render();
	}, 0);
}

views.graphsWeek = function()
{	
	var dateFrom = new Date().addWeeks(-1).addDays(1).clearTime();
	var dateTo = new Date().addDays(1).clearTime().addMinutes(-1);
	
	if(getParameterByName("from"))
	{
		dateFrom = Date.parse(getParameterByName("from"));
	}
	
	if(getParameterByName("to"))
	{
		dateTo = Date.parse(getParameterByName("to")).addDays(1).clearTime().addMinutes(-1);
	}
	
	var setupFoodDiaryLink = function()
	{
		var url = "#foodDiariesWeek?from=" + dateFrom.toString("dd-MMM-yyyy") + "&to=" + dateTo.toString("dd-MMM-yyyy");
		$(".checkFoodDiaryLink").attr("href", url);
	}
	
	var render = function()
	{	
		database.getWithinDates(dateFrom, dateTo, function(data)
		{
			var LoadStoolGraph = function()
			{
				var options = { grid: { clickable: false } };
			   	options.yaxis = { ticks: [1, 2, 3, 4, 5, 6, 7], tickDecimals : 0, min : 0, max : 8, axisLabel: 'Stool type' };
			   	options.xaxis = { ticks: [], min : -7, max : 1, axisLabel: 'Time' };
			   	options.lines = { show : false, fill : false };
			   	options.points = { show : true };
				var points = { color : "rgb(216, 58, 47)", data : [] };
				
				var previousDay = null;
				$(data).each(function(idx, item)
				{
					var dateAdded = Date.parse(item.dateAdded);
					if(!IsSameDay(previousDay, dateAdded))
					{
						previousDay = dateAdded;
						var xLabel = dateAdded.toString("MMM") + "<br/>" + dateAdded.toString("dd");
						var x = -DaysDifference(dateAdded, dateTo);
						options.xaxis.ticks.push([x, xLabel]);
					}
					if(item.bowelMovement)
					{
						var diff = -DaysDifference(dateAdded, dateTo);
						points.data.push([diff, parseInt(item.bowelMovement.type)]);
					}
				});
				
			    var graph = $.plot($("#stoolGraph"), [points], options);
			    graph.setupGrid(); //only necessary if your new data will change the axes or grid
				graph.draw();
			}
			
			var LoadSymptomsGraph = function()
			{
				var options = { grid: { clickable: false } };
			   	options.yaxis = { ticks: [1, 2, 3, 4, 5], tickDecimals : 0, min : 0, max : 6, axisLabel: 'Level' };
			   	options.xaxis = { ticks: [], min : -7, max : 1, axisLabel: 'Time' };
			   	options.lines = { show : true };
			   	options.points = { show : true };
			   	
			   	var points = {};
			   	
				points.feeling = {color : "rgb(73, 118, 51)", data : []};
				points.painLevel = {color : "#d5571d", data : []};
				points.stressLevel = {color : "rgb(75, 120, 196)", data : []};
				points.bloatingLevel = {color : "rgb(155, 0, 13)", data : []};
				points.nauseaLevel = {color : "#a08cb8", data : []};
				points.anxietyLevel = {color : "rgb(190, 108, 26)", data : []};
				points.lethargyLevel = {color : "rgb(121, 118, 124)", data : []};
				
				var previousDay = null;
				var groupedDays = {};
				var keys = [];
				$(data).each(function(idx, item)
				{
					var dateAdded = Date.parse(item.dateAdded);
					var x = -DaysDifference(dateAdded, dateTo);
					if(!IsSameDay(previousDay, dateAdded))
					{
						previousDay = dateAdded;
						var xLabel = dateAdded.toString("MMM") + "<br/>" + dateAdded.toString("dd");
						options.xaxis.ticks.push([x, xLabel]);
						keys.push(x);
						groupedDays[x] = {
							data : { 
									feeling : [],
									painLevel : [],
									stressLevel : [],
									bloatingLevel : [],
									nauseaLevel : [],
									anxietyLevel : [],
									lethargyLevel : []
								} 
						};
					}
					
					groupedDays[x].data.feeling.push(parseInt(item.feeling));
					groupedDays[x].data.painLevel.push(parseInt(item.painLevel));
					groupedDays[x].data.stressLevel.push(parseInt(item.stressLevel));
					groupedDays[x].data.bloatingLevel.push(parseInt(item.bloatingLevel));
					groupedDays[x].data.nauseaLevel.push(parseInt(item.nauseaLevel));
					groupedDays[x].data.anxietyLevel.push(parseInt(item.anxietyLevel));
					groupedDays[x].data.lethargyLevel.push(parseInt(item.lethargyLevel));
					
				});
				
				$(keys).each(function(idx, item)
				{
					points.feeling.data.push([item, groupedDays[item].data.feeling.avg()]);
					points.painLevel.data.push([item, groupedDays[item].data.painLevel.avg()]);
					points.stressLevel.data.push([item, groupedDays[item].data.stressLevel.avg()]);
					points.bloatingLevel.data.push([item, groupedDays[item].data.bloatingLevel.avg()]);
					points.nauseaLevel.data.push([item, groupedDays[item].data.nauseaLevel.avg()]);
					points.anxietyLevel.data.push([item, groupedDays[item].data.anxietyLevel.avg()]);
					points.lethargyLevel.data.push([item, groupedDays[item].data.lethargyLevel.avg()]);
				});
				
				var showAll = [ points.feeling, points.painLevel, points.stressLevel, points.bloatingLevel, points.nauseaLevel, points.anxietyLevel, points.lethargyLevel ];
				
			    var graph = $.plot($("#symptomsGraph"), showAll, options);
			    graph.setupGrid(); //only necessary if your new data will change the axes or grid
				graph.draw();
			    
			    $('.symptomsFilters span').tap(function()
			    {
			    	$(this).toggleClass('selected');
		    	
			    	if(this.id == "showAll" || $('.symptomsFilters span.selected').length == 0)
			    	{
			    		$('.symptomsFilters span').removeClass('selected');
			    		$('.symptomsFilters #showAll').addClass('selected');
			    		graph.setData(showAll);
			    	}else{
			    		$(".symptomsFilters #showAll").removeClass('selected');
			    		var selected = [];
			    		$('.symptomsFilters span.selected').each(function(idx, item)
			    		{
			    			selected.push(points[$(item).attr('id')]);
			    		});
			    		graph.setData(selected);
			    	}
			    	
		    		graph.setupGrid(); //only necessary if your new data will change the axes or grid
					graph.draw();
			    	
			    });
			}
			
			var LoadActivitiesGraph = function()
			{
				var options = { grid: { clickable: false } };
	
			   	options.xaxes = [ { ticks: [], min : -7, max : 1, axisLabel: 'Time' } ];
	    		options.yaxes = [ 
	    			{ ticks: [1, 2, 3, 4, 5], tickDecimals : 0, min : 0, max : 6, axisLabel: 'Amount of exercise' },
	    			{ ticks: [0, 5, 10, 15, 20], tickDecimals : 0, min : -1, max : 21, position: "right", axisLabel: 'Cups of fluid' }
	    		];
			   	
			   	options.lines = { show : true };
			   	options.points = { show : true };
			   	var points = {};
				points.activityLevel = { color : "rgb(207, 0, 74)", data : [], yaxis : 1 };
				points.fluidCups = { color : "rgb(30, 98, 170)", data : [], yaxis : 2 };
				
				var previousDay = null;
				var activityLevels = {};
				var keys = [];
				$(data).each(function(idx, item)
				{
					var dateAdded = Date.parse(item.dateAdded);
					var x = -DaysDifference(dateAdded, dateTo);
					if(!IsSameDay(previousDay, dateAdded))
					{
						previousDay = dateAdded;
						var xLabel = dateAdded.toString("MMM") + "<br/>" + dateAdded.toString("dd");
						options.xaxes[0].ticks.push([x, xLabel]);
						keys.push(x);
						activityLevels[x] = [];
						points.fluidCups.data.push([x, parseInt(item.fluidCups)]);
					}
					
					activityLevels[x].push(parseInt(item.activityLevel));
					
				});
				
				$(keys).each(function(idx, item)
				{
					points.activityLevel.data.push([item, activityLevels[item].avg()]);
				});
				
				
				var showAll = [ points.activityLevel, points.fluidCups ];
				
			    var graph = $.plot($("#activitiesGraph"), showAll, options);
			    graph.setupGrid(); //only necessary if your new data will change the axes or grid
				graph.draw();
			    
			    $('.activitiesFilters span').tap(function()
			    {
			    	$(this).toggleClass('selected');
	
			    	if(this.id == "showAll" || $('.activitiesFilters span.selected').length == 0)
			    	{
			    		$('.activitiesFilters span').removeClass('selected');
			    		$('.activitiesFilters #showAll').addClass('selected');
			    		graph.setData(showAll);
			    	}else{
			    		$('.activitiesFilters #showAll').removeClass('selected');
			    		var selected = [];
			    		$('.activitiesFilters span.selected').each(function(idx, item)
			    		{
			    			selected.push(points[$(item).attr('id')]);
			    		});
			    		graph.setData(selected);
			    	}
			    	
		    		graph.setupGrid(); //only necessary if your new data will change the axes or grid
					graph.draw();
					
					//Now sort out the y labels.
					$('#activitiesGraph .yaxisLabel, #activitiesGraph .y2axisLabel').hide();
					if($('.activitiesFilters #showAll.selected').length > 0)
					{
						$('#activitiesGraph .axisLabels').show();
					}
	    			if($('.activitiesFilters #fluidCups.selected').length > 0)
		    		{
		    			$('#activitiesGraph .y2axisLabel').show();
		    		}
		    		if($('.activitiesFilters #activityLevel.selected').length > 0)
		    		{
		    			$('#activitiesGraph .yaxisLabel').show();
		    		}
			    });
			}
			
			LoadStoolGraph();
			LoadSymptomsGraph();
			LoadActivitiesGraph();
			setupFoodDiaryLink();
			DoneLoading();
		});
	}
	
	var tpl = Handlebars.compile(TemplateLoader.templates['graphsWeek']);
	var html = tpl({ dateFrom : dateFrom.toString("dd MMM yyyy"), dateTo : dateTo.toString("dd MMM yyyy") });
	$('#content').html(html);
	SetupScroller();
	ShowLoading();
	window.setTimeout(function() {
		render();
	}, 0);
	
	$('.graphResultsWeek .previousGraph').live('tap', function()
	{
		//console.log("Calling Previous Graph - Week");
		dateFrom.add(-1).days();
		dateTo.add(-1).days();
		var tpl = Handlebars.compile(TemplateLoader.templates['graphsWeek']);
		var html = tpl({ dateFrom : dateFrom.toString("dd MMM yyyy"), dateTo : dateTo.toString("dd MMM yyyy") });
		$('#content').html(html);
		SetupScroller();
		setupFoodDiaryLink();
		ShowLoading();
		window.setTimeout(function() {
			render();
		}, 0);
	});
	
	$('.graphResultsWeek .nextGraph').live('tap', function()
	{
		var allowMoveForward = (dateTo.clone().clearTime() - new Date().clearTime()) < 0;
		if(!allowMoveForward)
		{
			return false;
		}
		dateFrom.add(1).days();
		dateTo.add(1).days();
		var tpl = Handlebars.compile(TemplateLoader.templates['graphsWeek']);
		var html = tpl({ dateFrom : dateFrom.toString("dd MMM yyyy"), dateTo : dateTo.toString("dd MMM yyyy") });
		$('#content').html(html);
		SetupScroller();
		setupFoodDiaryLink();
		ShowLoading();
		window.setTimeout(function() {
			render();
		}, 0);
	});
}

views.graphsMonth = function()
{	
	var dateFrom = new Date().addDays(1).clearTime().addMonths(-1);
	var dateTo = new Date().addDays(1).clearTime().addMinutes(-1);
	
	if(getParameterByName("from"))
	{
		dateFrom = Date.parse(getParameterByName("from"));
	}
	
	if(getParameterByName("to"))
	{
		dateTo = Date.parse(getParameterByName("to")).addDays(1).clearTime().addMinutes(-1);
	}
	
	var setupFoodDiaryLink = function()
	{
		var url = "#foodDiariesMonth?from=" + dateFrom.toString("dd-MMM-yyyy") + "&to=" + dateTo.toString("dd-MMM-yyyy");
		$(".checkFoodDiaryLink").attr("href", url);
	}
	
	var render = function()
	{		
		database.getWithinDates(dateFrom, dateTo, function(data)
		{	
			var LoadStoolGraph = function()
			{
				var options = { grid: { clickable: false } };
			   	options.yaxis = { ticks: [1, 2, 3, 4, 5, 6, 7], tickDecimals : 0, min : 0, max : 8, axisLabel: 'Stool type' };
			   	options.xaxis = { ticks: [], min : -32, max : 1, axisLabel: 'Time' };
			   	options.lines = { show : false, fill : false };
			   	options.points = { show : true };
				var points = { color : "rgb(216, 58, 47)", data : [] };
				
				var tickDate = dateTo.clone();
				for(var t = 0; t > -31; t-=5)
				{
					var xLabel = tickDate.toString("MMM") + "<br/>" + tickDate.toString("dd");
					options.xaxis.ticks.push([t, xLabel]);
					tickDate.add(-5).days();
				}
				
				$(data).each(function(idx, item)
				{
					var dateAdded = Date.parse(item.dateAdded);
					if(item.bowelMovement)
					{
						var x = -DaysDifference(dateAdded, dateTo);
						points.data.push([x, parseInt(item.bowelMovement.type)]);
					}
				});
				
			    var graph = $.plot($("#stoolGraph"), [points], options);
			    graph.setupGrid(); //only necessary if your new data will change the axes or grid
				graph.draw();
			}
			
			var LoadSymptomsGraph = function()
			{
				var options = { grid: { clickable: false } };
			   	options.yaxis = { ticks: [1, 2, 3, 4, 5], tickDecimals : 0, min : 0, max : 6, axisLabel: 'Level' };
			   	options.xaxis = { ticks: [], min : -32, max : 1, axisLabel: 'Time' };
			   	options.lines = { show : true };
			   	options.points = { show : true };
			   	
			   	var points = {};
			   	
				points.feeling = {color : "rgb(73, 118, 51)", data : []};
				points.painLevel = {color : "#d5571d", data : []};
				points.stressLevel = {color : "rgb(75, 120, 196)", data : []};
				points.bloatingLevel = {color : "rgb(155, 0, 13)", data : []};
				points.nauseaLevel = {color : "#a08cb8", data : []};
				points.anxietyLevel = {color : "rgb(190, 108, 26)", data : []};
				points.lethargyLevel = {color : "rgb(121, 118, 124)", data : []};
				
				var tickDate = dateTo.clone();
				for(var t = 0; t > -31; t-=5)
				{
					var xLabel = tickDate.toString("MMM") + "<br/>" + tickDate.toString("dd");
					options.xaxis.ticks.push([t, xLabel]);
					tickDate.add(-5).days();
				}
				
				var previousDay = null;
				var groupedDays = {};
				var keys = [];
				$(data).each(function(idx, item)
				{
					var dateAdded = Date.parse(item.dateAdded);
					var x = -DaysDifference(dateAdded, dateTo);
					if(!IsSameDay(previousDay, dateAdded))
					{
						previousDay = dateAdded;
						keys.push(x);
						groupedDays[x] = {
							data : { 
									feeling : [],
									painLevel : [],
									stressLevel : [],
									bloatingLevel : [],
									nauseaLevel : [],
									anxietyLevel : [],
									lethargyLevel : []
								} 
						};
					}
					
					groupedDays[x].data.feeling.push(parseInt(item.feeling));
					groupedDays[x].data.painLevel.push(parseInt(item.painLevel));
					groupedDays[x].data.stressLevel.push(parseInt(item.stressLevel));
					groupedDays[x].data.bloatingLevel.push(parseInt(item.bloatingLevel));
					groupedDays[x].data.nauseaLevel.push(parseInt(item.nauseaLevel));
					groupedDays[x].data.anxietyLevel.push(parseInt(item.anxietyLevel));
					groupedDays[x].data.lethargyLevel.push(parseInt(item.lethargyLevel));
					
				});
				
				$(keys).each(function(idx, item)
				{
					points.feeling.data.push([item, groupedDays[item].data.feeling.avg()]);
					points.painLevel.data.push([item, groupedDays[item].data.painLevel.avg()]);
					points.stressLevel.data.push([item, groupedDays[item].data.stressLevel.avg()]);
					points.bloatingLevel.data.push([item, groupedDays[item].data.bloatingLevel.avg()]);
					points.nauseaLevel.data.push([item, groupedDays[item].data.nauseaLevel.avg()]);
					points.anxietyLevel.data.push([item, groupedDays[item].data.anxietyLevel.avg()]);
					points.lethargyLevel.data.push([item, groupedDays[item].data.lethargyLevel.avg()]);
				});
				
				var showAll = [ points.feeling, points.painLevel, points.stressLevel, points.bloatingLevel, points.nauseaLevel, points.anxietyLevel, points.lethargyLevel ];
				
			    var graph = $.plot($("#symptomsGraph"), showAll, options);
			    graph.setupGrid(); //only necessary if your new data will change the axes or grid
				graph.draw();
			    
			    
			    $('.symptomsFilters span').tap(function()
			    {
			    	$(this).toggleClass('selected');
		    	
			    	if(this.id == "showAll" || $('.symptomsFilters span.selected').length == 0)
			    	{
			    		$('.symptomsFilters span').removeClass('selected');
			    		$('.symptomsFilters #showAll').addClass('selected');
			    		graph.setData(showAll);
			    	}else{
			    		$(".symptomsFilters #showAll").removeClass('selected');
			    		var selected = [];
			    		$('.symptomsFilters span.selected').each(function(idx, item)
			    		{
			    			selected.push(points[$(item).attr('id')]);
			    		});
			    		graph.setData(selected);
			    	}
			    	
		    		graph.setupGrid(); //only necessary if your new data will change the axes or grid
					graph.draw();
			    	
			    });
			}
			
			var LoadActivitiesGraph = function()
			{
				var options = { grid: { clickable: false } };
	
			   	options.xaxes = [ { ticks: [], min : -32, max : 1, axisLabel: 'Time' } ];
	    		options.yaxes = [ 
	    			{ ticks: [1, 2, 3, 4, 5], tickDecimals : 0, min : 0, max : 6, axisLabel: 'Amount of exercise' },
	    			{ ticks: [0, 5, 10, 15, 20], tickDecimals : 0, min : -1, max : 21, position: "right", axisLabel: 'Cups of fluid'  }
	    		];
	    		
	    		var tickDate = dateTo.clone();
				for(var t = 0; t > -31; t-=5)
				{
					var xLabel = tickDate.toString("MMM") + "<br/>" + tickDate.toString("dd");
					options.xaxes[0].ticks.push([t, xLabel]);
					tickDate.add(-5).days();
				}
			   	
			   	options.lines = { show : true };
			   	options.points = { show : true };
			   	var points = {};
				points.activityLevel = { color : "rgb(207, 0, 74)", data : [], yaxis : 1 };
				points.fluidCups = { color : "rgb(30, 98, 170)", data : [], yaxis : 2};
				
				var previousDay = null;
				var activityLevels = {};
				var keys = [];
				$(data).each(function(idx, item)
				{
					var dateAdded = Date.parse(item.dateAdded);
					var x = -DaysDifference(dateAdded, dateTo);
					if(!IsSameDay(previousDay, dateAdded))
					{
						previousDay = dateAdded;
						keys.push(x);
						activityLevels[x] = [];
						points.fluidCups.data.push([x, parseInt(item.fluidCups)]);
					}
					
					activityLevels[x].push(parseInt(item.activityLevel));
					
				});
				
				$(keys).each(function(idx, item)
				{
					points.activityLevel.data.push([item, activityLevels[item].avg()]);
				});
				
				var showAll = [ points.activityLevel, points.fluidCups ];
				
			    var graph = $.plot($("#activitiesGraph"), showAll, options);
			    graph.setupGrid(); //only necessary if your new data will change the axes or grid
				graph.draw();
			    
			    $('.activitiesFilters span').tap(function()
			    {
			    	$(this).toggleClass('selected');

			    	if(this.id == "showAll" || $('.activitiesFilters span.selected').length == 0)
			    	{
			    		$('.activitiesFilters span').removeClass('selected');
			    		$('.activitiesFilters #showAll').addClass('selected');
			    		graph.setData(showAll);
			    	}else{
			    		$('.activitiesFilters #showAll').removeClass('selected');
			    		var selected = [];
			    		$('.activitiesFilters span.selected').each(function(idx, item)
			    		{
			    			selected.push(points[$(item).attr('id')]);
			    		});
			    		graph.setData(selected);
			    	}
			    	
		    		graph.setupGrid(); //only necessary if your new data will change the axes or grid
					graph.draw();
					
					//Now sort out the y labels.
					$('#activitiesGraph .yaxisLabel, #activitiesGraph .y2axisLabel').hide();
					if($('.activitiesFilters #showAll.selected').length > 0)
					{
						$('#activitiesGraph .axisLabels').show();
					}
	    			if($('.activitiesFilters #fluidCups.selected').length > 0)
		    		{
		    			$('#activitiesGraph .y2axisLabel').show();
		    		}
		    		if($('.activitiesFilters #activityLevel.selected').length > 0)
		    		{
		    			$('#activitiesGraph .yaxisLabel').show();
		    		}
			    	
			    });
			}
			
			LoadStoolGraph();
			LoadSymptomsGraph();
			LoadActivitiesGraph();
			setupFoodDiaryLink();
			DoneLoading();
		});
	
	}
	
	var tpl = Handlebars.compile(TemplateLoader.templates['graphsMonth']);
	var html = tpl({ dateFrom : dateFrom.toString("dd MMM yyyy"), dateTo : dateTo.toString("dd MMM yyyy") });
	$('#content').html(html);
	SetupScroller();
	ShowLoading();
	window.setTimeout(function() {
			render();
	}, 0);
	
	$('.graphResultsMonth .previousGraph').live('tap', function()
	{
		dateFrom.add(-1).months();
		dateTo.add(-1).months();
		var tpl = Handlebars.compile(TemplateLoader.templates['graphsMonth']);
		var html = tpl({ dateFrom : dateFrom.toString("dd MMM yyyy"), dateTo : dateTo.toString("dd MMM yyyy") });
		$('#content').html(html);
		SetupScroller();
		setupFoodDiaryLink();
		ShowLoading();
		window.setTimeout(function() {
			render();
		}, 0);
	});
	
	$('.graphResultsMonth .nextGraph').live('tap', function()
	{
		var allowMoveForward = (dateTo.clone().clearTime() - new Date().clearTime()) < 0;
		if(!allowMoveForward)
		{
			return false;
		}
		dateFrom.add(1).months();
		dateTo.add(1).months();
		var tpl = Handlebars.compile(TemplateLoader.templates['graphsMonth']);
		var html = tpl({ dateFrom : dateFrom.toString("dd MMM yyyy"), dateTo : dateTo.toString("dd MMM yyyy") });
		$('#content').html(html);
		SetupScroller();
		setupFoodDiaryLink();
		ShowLoading();
		window.setTimeout(function() {
			render();
		}, 0);
	});
}