var currentDailyEntry,
	currentBM,
	hadBowelMovement,
	currentField = $(this);

function ResetData()
{
	currentDailyEntry = undefined;
	currentBM = undefined;
	hadBowelMovement = false;
	$('#foodDiary').val('');
}

views.newEntry1 = function()
{
	var render = function()
	{
		$('footer').removeClass();
        $('footer').addClass("trackerTab");
		
		database.getAllForDay(new Date(), function(todays)
		{
			var viewModel = { "bm" : currentBM, "hadBowelMovement" : hadBowelMovement },
				tpl = Handlebars.compile(TemplateLoader.templates['newEntry1']),
				html = tpl(viewModel);
			
			
			$('#content').html(html);

			
			if(hadBowelMovement)
			{
				displaySelectedStoolImageInList(currentBM.type);
				displaySelectedDateInList(currentBM.time);
			}
			
			//SETUP COMPONENTS
			SetupCalendar();
			SetupScroller();
			SetupPills();
			SetupSliders();
			ToggleStoolType();
			ToggleBMDetails();
			
			//glow();
			
			/*$('#lastBMQuestion').tap(function(e)
			{
				e.preventDefault(); 
				var time = new Date();
				if(currentBM.time)
				{
					//time = Date.parse(currentBM.time);
					time = ((currentBM.time instanceof Date) ? currentBM.time : Date.parse(currentBM.time));
				}
				plugins.datePicker.show({
					date: time,
					mode: 'time', //date or time or blank for both
					allowOldDates: true
				}, SetLastBM);
			});*/

			$('#lastBMQuestion').tap(function(e)
			{
				e.preventDefault(); 
				var time = new Date();
				if(currentBM.time)
				{
					//time = Date.parse(currentBM.time);
					time = ((currentBM.time instanceof Date) ? currentBM.time : Date.parse(currentBM.time));
				}
				var options = {
				  date: time,
				  mode: 'time'
				};

				datePicker.show(options, function(date){
				  if(isValidDate(date)) {
  					  SetLastBM(date);
				  }
				});
			});
			
			$('.calendar').tap(function(e)
			{
				e.preventDefault(); 
				var date = new Date();
				if(currentBM.date)
				{
					//date = Date.parse(currentBM.date);
					date = ((currentBM.date instanceof Date) ? currentBM.date : Date.parse(currentBM.date));
				}
				var options = {
				  date: date,
				  mode: 'date'
				};

				datePicker.show(options, function(date){
				  if(isValidDate(date)) {
  					  UpdateDate(date);
				  }
				});


			});
		
			$('#stoolTypeQuestion').tap(function(e)
			{
				e.preventDefault();
				$('#stoolTypePopup').show();
			});
			
			$('#stoolTypePopup .save').tap(function(e)
			{
				e.preventDefault();
				$('#stoolTypePopup').hide();
				displaySelectedStoolImageInList($('#stoolRating').val());
				return false;
			});
			
		
			$('#stoolRating').live('change', ToggleStoolType);
			$('#hadBowelMovement').live('change', ToggleBMDetails);
			
			$('.next, .nextStepLeadIn').tap(function(e)
			{
				e.preventDefault();
				ShowLoading();
				SaveBowelMovement();
			});
			
			DoneLoading();
		});
		
	};
	
	var loadEntry = function()
	{
		if(!currentBM)
		{
			currentBM = jQuery.extend(true, {}, defaultBowelMovement);
		}
		
		//LOAD TODAYS ENTRY
		if(!currentDailyEntry)
		{
			// Get defaults from a previous entry from earlier today
			database.getLatestForToday(function(entry)
			{
				// If first of the day take the boilerplate defaults.
				if(!entry)
				{
					currentDailyEntry = jQuery.extend(true, {}, defaultDailyEntry);
				}
				else
				{
					currentDailyEntry = jQuery.extend(true, {}, entry);
					currentDailyEntry.id = undefined;
					currentDailyEntry.bowelMovement = null;
					currentDailyEntry.dateAdded = undefined;
					currentDailyEntry.additionalNotes = undefined;
					currentDailyEntry.foodDiary = undefined;
				}
				render();
			});
		}
		else
		{
			render();
		}
	}
	
	ShowLoading();
	window.setTimeout(function() {
		loadEntry();
	}, 0);
	
	//EVENTS
	function ToggleBMDetails()
	{
		if($('#hadBowelMovement').attr('checked'))
		{
			$('.bmDetails').show();
			hadBowelMovement = true;
		}else{
			$('.bmDetails').hide();
			hadBowelMovement = false;
		}
		RefreshScroller();
	};
	
	function displaySelectedStoolImageInList(stoolType)
	{
		var imgHtml = '<img src="images/stools/type' + stoolType + '.png" />';
		$('#stoolTypeQuestion .answer').html(imgHtml);
		$('#stoolTypeQuestion').removeClass('arrowed');
	}
			
	function displaySelectedDateInList(date)
	{
		if (!date)
		{
			date = new Date();
		}
		$('#lastBMQuestion .answer').text(date.toString("HH:mm"));
		$('#lastBMQuestion').removeClass('arrowed');
		
	}
	
	function ToggleStoolType()
	{
		var selectedValue = $('#stoolRating').val();
		$('.stoolSample').each(function()
		{
			if($(this).data('sample') == selectedValue)
			{
				$(this).show();
			}else{
				$(this).hide();
			}
		});
	}
	
	function SetLastBM(date)
	{

		if (currentBM.date) 
		{
			var d= new Date(currentBM.date),
				t= new Date(date);
			currentBM.time = new Date(d.getFullYear(), d.getMonth(), d.getDate(),
					t.getHours(), t.getMinutes(), t.getSeconds());
			displaySelectedDateInList(currentBM.time);
		}else{
			currentBM.time = new Date(date);
			displaySelectedDateInList(currentBM.time);
		}
		currentField.blur();
	}
	
	function UpdateDate(date)
	{
		// date is correct 2013/7/27 needs to be joined with currentBM.time like above
		/*var d = new Date(date);
		var t = new Date();*/
		
		if (currentBM.time){
			var d = new Date(date),
				t = new Date(currentBM.time);
			currentBM.time = new Date(d.getFullYear(), d.getMonth(), d.getDate(),
					t.getHours(), t.getMinutes(), t.getSeconds());
		}
		
		currentBM.date = date;
		UpdateCalendar(date);
		currentField.blur();	
		
		
		/*currentBM.date = date;
		console.log(date + currentBM.time);
		UpdateCalendar(date);
		currentField.blur();*/
	}

	//-- SAVE PROGRESS BEFORE NEXT STEP --//
	function SaveBowelMovement()
	{
		currentBM.type = $('#stoolRating').val();
		currentBM.strained = $('#strained').is(':checked');
		currentBM.feltFinished = $('#feltFinished').is(':checked');
		currentBM.urgent = $('#urgent').is(':checked');
		currentBM.mucus = $('#mucus').is(':checked');
		currentBM.easedPain = $('#easedPain').is(':checked');
		if(!currentBM.time)
		{
			currentBM.time = new Date();
		}
	}
	
};
	
	
//-- YOUR SYMPTOMS --//
views.newEntry2 = function()
{
	var tpl = Handlebars.compile(TemplateLoader.templates['newEntry2']),
	html = tpl(currentDailyEntry);
	
	$('#content').html(html);
	
	//SetupCalendar();
	calendarSync();
	
	var howYourFeelingSelector = ".howYourFeeling li:nth-child("+currentDailyEntry.feeling+")";
	$(howYourFeelingSelector).addClass('active');
	
	$('.howYourFeeling li').live('tap', function(e)
	{
		e.preventDefault();
		$('.howYourFeeling li').each(function(index) {
		  $(this).removeClass('active');
		});
		
		$(this).addClass('active');
	}); 
	
	SetupScroller();
	SetupRangePickers();
	
	//-- SAVE PROGRESS --//
	var SaveSymptoms = function()
	{
		
		currentDailyEntry.feeling = $('.howYourFeeling li.active').index()+1;
		currentDailyEntry.painLevel = $('#painLevel').attr('data-selected');
		currentDailyEntry.stressLevel = $('#stressLevel').attr('data-selected');
		currentDailyEntry.bloatingLevel = $('#bloatingLevel').attr('data-selected');
		currentDailyEntry.nauseaLevel = $('#nauseaLevel').attr('data-selected');
		currentDailyEntry.anxietyLevel = $('#anxietyLevel').attr('data-selected');
		currentDailyEntry.lethargyLevel = $('#lethargyLevel').attr('data-selected');
	}
	
	$('.next, .nextStepLeadIn').tap(function()
	{
		SaveSymptoms();
	});
};
	
//-- DIET & ACTIVITIES --//
views.newEntry3 = function()
{
	var tpl = Handlebars.compile(TemplateLoader.templates['newEntry3']),
	html = tpl(currentDailyEntry);
	$('#content').html(html);
	
	//SetupCalendar();
	calendarSync();
	
	var setCupCountText = function()
	{
		var val = pad(Math.round($('#numberOfCups').val()), 2);
    	$('.cupsCount').text(val);
	}
	setCupCountText();
	
	$('#numberOfCups').change(function()
                      {
                            setCupCountText();
                      });
	SetupScroller();
	SetupPills();
	SetupRangePickers();
	SetupSliders();
	
	//FOOD DIARY POPUP
	$('#foodDiaryQuestion').tap(function(e)
	{
		e.preventDefault();
		$('#foodDiaryPopup').show();
	});
	
	$('#foodDiaryPopup .save').tap(function(e)
	{
		e.preventDefault();
		$('#foodDiaryPopup').hide();
		return false;
	});
	
	//ADDITIONAL NOTES
	$('#additionalNotesQuestion').tap(function(e)
	{
		e.preventDefault();
		$('#additionalNotesPopup').show();
	});
	
	$('#additionalNotesPopup .save').tap(function(e)
	{
		e.preventDefault();
		$('#additionalNotesPopup').hide();
		return false;
	});
	
	// -- SAVE IT TO MEMORY --//
	var SaveDiet = function()
	{
		currentDailyEntry.fluidCups = $('#numberOfCups').val();
		currentDailyEntry.activityLevel = $('#activityLevel').attr('data-selected');
		currentDailyEntry.painFromEating = $('#painFromEating').is(':checked');
		currentDailyEntry.foodDiary = $('#foodDiary').val();
		currentDailyEntry.additionalNotes = $('#additionalNotes').val();
	}
	
	$('.back').tap(function(e)
	{
		e.preventDefault();
		SaveDiet();
	});
	
	$('.newEntryHeader .save, .nextStepLeadIn').tap(function(e)
	{
		e.preventDefault();
		SaveDiet();
		if(hadBowelMovement)
		{
			currentDailyEntry.bowelMovement = currentBM;
			//console.log("====>" + Date.parse(currentBM.time).toString("yyyy-MM-dd HH:mm:ss"));
			currentDailyEntry.dateAdded = currentBM.time.toString(dateTimeFormat);
		}
		database.saveEntry(currentDailyEntry, function()
		{
			console.log("Save new entry cb. Loading graph24.");
			ResetData();
			document.location.hash = "#graphs24";
			views["graphs24"]();
		});
		//-- SAVE TO DATABASE AND DO GRAPHING STUFF --//
	});

};
