views.shareResults = function()
{
	
	/* ------------------------*/
	/* -- GET THE DATE RANGE --*/
	/* ------------------------*/
	
	//Defaults last day.
	var currentField = $(this);
	var dateFrom = new Date().addDays(-1).clearTime();
	var dateTo = new Date().clearTime();
	
	$('#content').html(TemplateLoader.templates['shareResults']);
	
	//Update the text in the buttons to reflect the dates
	var updateDateLabels = function()
	{
		$('.dateOption.from span').text(dateFrom.toString('dd/MM/yyyy'));
		$('.dateOption.to span').text(dateTo.toString('dd/MM/yyyy'));
	}
	
	updateDateLabels();
	
	//Toggle the selection state
	$('.dateOption').tap(function()
	{
		if(!$(this).hasClass('selected'))
		{
			$('.dateOption').toggleClass('selected');
		}
	});
	
	var validateDates = function()
	{
		if(dateFrom.compareTo(dateTo) > 0)
		{
			dateFrom = dateTo.clone();
		}
		
		updateDateLabels();
	}
	
	
	//Open the date picker component
	var setDateFrom = function()
	{
		var options = {
		  date: dateFrom,
		  mode: 'date'
		};

		datePicker.show(options, function(date){
		  if(isValidDate(date)) {
			  dateFrom = new Date(date);
			  validateDates();
              currentField.blur();
		  }
		});
	};
	
	var setDateTo = function()
	{

		var options = {
		  date: dateTo,
		  mode: 'date'
		};

		datePicker.show(options, function(date){
		  if(isValidDate(date)) {
			  dateTo = new Date(date);
			  validateDates();
              currentField.blur();
		  }
		});
	};
	
	$('.to').tap(setDateTo);
	$('.from').tap(setDateFrom);
	
	
	
	/* ----------------------------------------*/
	/* -- CREATE THE EMAIL AND OPEN COMPOSER --*/
	/* ----------------------------------------*/
	
	//Create the email and open the email composer.
	$('.emailButton').tap(function()
	{
		ShowLoading();
		database.getWithinDates(dateFrom, dateTo, function(data)
		{
		
			
			var subject = "Patient IBS: " + dateFrom.toString("dd-MMMM-yyyy") + " to " + dateTo.toString("dd-MMMM-yyyy");
			var vm = { entries : data, dateFrom : dateFrom.toString("dd-MM-yyyy"), dateTo : dateTo.toString("dd-MM-yyyy")};
			var tpl = Handlebars.compile(TemplateLoader.templates['shareEmail']);
			var html = tpl(vm);
			DoneLoading();

            
            var extras = {};
            extras[window.plugins.webintent.EXTRA_SUBJECT] = subject;
            extras[window.plugins.webintent.EXTRA_TEXT] = html;

            window.plugins.webintent.startActivity({
                action: window.plugins.webintent.ACTION_SEND,
                type: 'text/html', 
                extras: extras 
              }, 
              function() {
                  console.log("Email opened");
              }, 
              function() {
                  console.log("Email failed");
              }
            ); 
            
            return false;
            
            
		});
	});
	
}