var views = {

	home : function()
	{
		$('#content').html(TemplateLoader.templates['home']);
		SetupScroller();
	},
	
	learn : function()
	{
		
		ShowLoading();
		var ref = window.open('http://www.patient.co.uk/health/Irritable-Bowel-Syndrome.htm');
		ref.addEventListener('exit', function(event) {
        	document.location.hash = "#home";
        	views["home"]();
		 });

	},
	
	ibslink : function()
	{
       
		ShowLoading();
        var ref = window.open('http://www.theibsnetwork.org/');
	},
	
	upgradeIBS : function()
	{
    	
		ShowLoading();
    	var ref = window.open('http://market.android.com/details?id=com.patientuk.ibstrack&hl=en');
	},
	
	patibs : function()
	{

		ShowLoading();
    	var ref = window.open('http://www.patient.co.uk/forums/discuss/browse/irritable-bowel-syndrome-1211');
	},
	
	about : function()
	{
		$('#content').html(TemplateLoader.templates['about']);
		SetupScroller();
		
		$('#loadSmall').tap(function()
		{
			ShowLoading();
			database.nukeData(database.loadTestData(50));
		});
		
		$('#loadMedium').tap(function()
		{
			ShowLoading();
			database.nukeData(database.loadTestData(100));
		});
		
		$('#loadLarge').tap(function()
		{
			ShowLoading();
			database.nukeData(database.loadTestData(1000));
		});
		
		$('#nuke').tap(function()
		{
			navigator.notification.confirm("Are you sure?", function(btn)
			{
				if(btn == 1)
				{
					database.nukeData(function()
					{
						
					});
				}
			}, "Clear data", "Yes, No")
		});
		
		$('#searchForm').submit(function(event)
		{
			ShowLoading();
			event.preventDefault();

			var query = $("#tbSearch").val();
			if(query.length > 0)
			{
				var url = "http://www.patient.co.uk/Search.asp?searchTerm=";
				var completeurl = window.location.href = url + query;
				
			
		        var ref = window.open(completeurl);
				ref.addEventListener('exit', function(event) { 
					document.location.hash = "#about";
		        	views["about"]();
				});
			}
		});
	},
	
	trackerHome : function()
	{
		$('#content').html(TemplateLoader.templates['trackerHome']);
		SetupScroller();
	},

	viewAllEntries : function()
	{
		var loadEntries = function()
		{
			var tpl = Handlebars.compile(TemplateLoader.templates['viewAllEntries']);
			
			database.getAllEntries(function(data)
			{
				var result = {};
				var months = [];
				var len = data.length;
				for(var i = 0; i < len; i++)
				{

					var deight = new Date(data[i].value.dateAdded);
					deight = deight.toString("yyyy-MM");
					//console.log(deight);

					//console.log("important" + deight.toString(dateTimeFormat));
					var key = deight;
					//works var key = Date.parse(data[i].value.dateAdded).toString("yyyy-MM");
					//var key = Date.parseExact(data[i].value.dateAdded, "MMM dd, yyy HH:mm:ss tt");
					if(!result[key])
					{
						months.push(key);
						result[key] = [];
					}
					result[key].push(data[i].value);
				}
				
				months.sort().reverse();
				
				var viewModel = { months : months, entries : result };
				
				$('#content').html(tpl(viewModel));
				SetupScroller();
				DoneLoading();
			});
		}
		
		$('#content').html(TemplateLoader.templates['viewAllEntries']);
		$('#wrapper').hide();
		ShowLoading();
		window.setTimeout(function() {
			loadEntries();
		}, 0);
	},
	
	viewEntry : function(id)
	{
		var loadEntry = function()
		{
			ShowLoading();
			var entry,
				tpl = Handlebars.compile(TemplateLoader.templates['viewEntry']);
			database.getEntry(id, function(data)
			{
				//var entry = data.value;
				entry = data.value;
				var vm = { hadBowelMovement : entry.bowelMovement != null, entry : entry };
				var dateAdded = Date.parse(entry.dateAdded);
				database.getAllForDay(dateAdded, function(todays)
				{
					todays.sort(SortEntriesByDateAdded);
					var withBMS = [];
					$(todays).each(function(i, dayEntry)
					{
						if(dayEntry.bowelMovement != null)
						{
							withBMS.push(dayEntry);
						}
					});
					vm.bmsToday = 0;
					if(withBMS.length > 0)
					{
						vm.bmsToday = withBMS.length;
						vm.lastBM = Date.parse(withBMS[0].dateAdded).toString("HH:mm");
					}
					vm.dateAdded = dateAdded.toString("HH:mm");
					var html = tpl(vm);
					$('#content').html(html);
					
					var howYourFeelingSelector = ".howYourFeeling li:nth-child("+entry.feeling+")";
					$(howYourFeelingSelector).addClass('active');
					
					$('.howYourFeeling li').live('tap', function()
					{
						$('.howYourFeeling li').each(function(index) {
						  $(this).removeClass('active');
						});
						
						$(this).addClass('active');
					});
					
					// Change calendar
					$('.viewEntry .calendar').tap( function () {
						var date = new Date();
						if(entry.dateAdded)
						{
							date = Date.parse(entry.dateAdded);
							if (date === null){
                                date = new Date(entry.dateAdded);
                            }
						}

						var options = {
						  date: date,
						  mode: 'date'
						};

						datePicker.show(options, function(date){
						  if(isValidDate(date)) {
		  					  UpdateDate(date);
						  }
						});
					});
					
					function UpdateDate(date)
					{
						if (entry.dateAdded) 
						{
							d= new Date(date);
							t= new Date(entry.dateAdded);
							entry.dateAdded = new Date(d.getFullYear(), d.getMonth(), d.getDate(),
									t.getHours(), t.getMinutes(), t.getSeconds());
						}else{
							entry.dateAdded = date;
						}
						UpdateCalendar(entry.dateAdded);
						currentField.blur();
					}
					
					$('.timeHeader').tap(function()
					{
						var time = new Date();
						if(entry.dateAdded)
						{
							time = Date.parse(entry.dateAdded);
							// New 
							if (time === null){
                                time = new Date(entry.dateAdded);
                            }
						}

						var options = {
						  date: time,
						  mode: 'time'
						};

						datePicker.show(options, function(date){
						  if(isValidDate(date)) {
		  					  UpdateTime(date);
						  }
						});
					});
					
					function UpdateTime(time)
					{
						if (entry.dateAdded) 
						{
							d= new Date(entry.dateAdded);
							console.log(d);
							t= new Date(time);
							entry.dateAdded = new Date(d.getFullYear(), d.getMonth(), d.getDate(),
									t.getHours(), t.getMinutes(), t.getSeconds());
						}else{
							entry.dateAdded = time;
						}
						//var d = new Date(entry.dateAdded);
						//$('.timeHeader').text(entry.dateAdded.getHours() + " " + entry.dateAdded.getMinutes());
						$('.timeHeader').text(entry.dateAdded.toString("HH:mm"));
						currentField.blur();
					}
					
					//FOOD DIARY POPUP
					$('#view_foodDiary').tap(function()
					{
						$('#foodDiaryPopup').show();
						$('#foodDiary').val($('#view_foodDiary').text());
					});
					
					$('#foodDiaryPopup .save').tap(function()
					{
						$('#foodDiaryPopup').hide();
						var fooddiary = $('#foodDiary').val();
						$('#view_foodDiary').text(fooddiary);
						return false;
					});
					
					//ADDITIONAL NOTES
					$('#view_additionalNotes').tap(function()
					{
						$('#additionalNotesPopup').show();
						$('#additionalNotes').val($('#view_additionalNotes').text());
					});
					
					$('#additionalNotesPopup .save').tap(function()
					{
						$('#additionalNotesPopup').hide();
						var addtionalnotes = $('#additionalNotes').val();
						$('#view_additionalNotes').text(addtionalnotes);
						return false;
					});
					
					$('.viewEntryHeader .save').tap( function() {
						var editedBM = jQuery.extend(true, {}, defaultDailyEntry);;
						editedBM.id = entry.id;
						editedBM.bowelMovement = entry.bowelMovement;
						editedBM.dateAdded = entry.dateAdded;
						editedBM.bowelMovement.type = $('#stoolRating').val();
						editedBM.bowelMovement.strained = $('#view_strained').is(':checked');
						editedBM.bowelMovement.feltFinished = $('#view_feltFinished').is(':checked');
						editedBM.bowelMovement.urgent = $('#view_urgent').is(':checked');
						editedBM.bowelMovement.mucus = $('#view_mucus').is(':checked');
						editedBM.bowelMovement.easedPain = $('#view_easedPain').is(':checked');
						editedBM.feeling = $('.howYourFeeling li.active').index()+1;
						editedBM.painLevel = $('#view_painLevel').attr('data-selected');
						editedBM.stressLevel = $('#view_stressLevel').attr('data-selected');
						editedBM.bloatingLevel = $('#view_bloatingLevel').attr('data-selected');
						editedBM.nauseaLevel = $('#view_nauseaLevel').attr('data-selected');
						editedBM.anxietyLevel = $('#view_anxietyLevel').attr('data-selected');
						editedBM.lethargyLevel = $('#view_lethargyLevel').attr('data-selected');
						editedBM.fluidCups = $('#view_numberOfCups').text();
						editedBM.activityLevel = $('#view_activityLevel').attr('data-selected');
						editedBM.painFromEating = $('#view_painFromEating').is(':checked');
						editedBM.foodDiary = $('#view_foodDiary').text();
						editedBM.additionalNotes = $('#view_additionalNotes').text();
						database.saveEntry(editedBM, function()
						{
							editedBM = undefined;
							document.location.hash = "#viewAllEntries";
							
						});
					});
					
					$('#view_stoolTypeQuestion').tap(function()
					{
						$('#stoolTypePopup').show();
						ToggleStoolType();
					});
					
					$('#stoolTypePopup .save').tap(function()
					{
						$('#stoolTypePopup').hide();
						$('#stoolRating').val($('div.stoolSample.active').attr('data-sample'));
						displaySelectedStoolImageInList($('#stoolRating').val());
						//return false;
					});
					
					function ToggleStoolType()
					{
						var selectedValue = $('#stoolRating').val();
						$('.stoolSample').each(function()
						{
							if($(this).data('sample') == selectedValue)
							{
								$(this).show().addClass('active');
							}else{
								$(this).hide();
							}
						});
					}
					function displaySelectedStoolImageInList(stoolType)
					{
						var imgHtml = '<img src="images/stools/type' + stoolType + '.png" />';
						$('#view_stoolTypeQuestion .answer').html(imgHtml);
						$('#view_stoolTypeQuestion').removeClass('arrowed');
					}
					
					// Cups of fluid edit
					$('#cupfluid-container .less').tap( function () {
						var cupsOfFluid = $('#view_numberOfCups').text();
						$('#view_numberOfCups').text(--cupsOfFluid);
					});
					$('#cupfluid-container .more').tap( function () {
						var cupsOfFluid = $('#view_numberOfCups').text();
						$('#view_numberOfCups').text(++cupsOfFluid);
					});
					
					// Stool sample switcher
					/*$('#stoolTypePopup .save').tap( function () {
						$('#stoolRating').val($('div.stoolSample.active').attr('data-sample'));
					});*/
					$('#nextStool').tap( function () {
						if ($('div.stoolSample.active').next('.stoolSample').length){
							$('div.stoolSample.active').removeClass('active').hide().next().addClass('active').show();
						}
					});
					$('#prevStool').tap( function () {
						if ($('div.stoolSample.active').prev('.stoolSample').length){
							$('div.stoolSample.active').removeClass('active').hide().prev().addClass('active').show();
						}
					});
					
					
					SetupCalendar(dateAdded);
					SetupPills();
					SetupRangePickers();
					SetupSliders();
					SetupScroller();
					DoneLoading();
				});
			});
			
			

		}
		
		//ShowLoading();
		window.setTimeout(function() {
			loadEntry();
		}, 0);
		
	}
}